"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_1 = require("react");
var CodepenEmbedScriptTagBuilder_1 = __importDefault(require("./CodepenEmbedScriptTagBuilder"));
var ReactCodepen = /** @class */ (function (_super) {
    __extends(ReactCodepen, _super);
    function ReactCodepen(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this.state = { loaded: false, loading: true, error: undefined };
        _this.scriptTagBuilder = new CodepenEmbedScriptTagBuilder_1.default()
            .setAsync(true)
            .withOnLoadHandler(_this.handleScriptLoad.bind(_this))
            .withOnErrorHandler(_this.handleScriptError.bind(_this));
        return _this;
    }
    ReactCodepen.prototype.componentDidMount = function () {
        this._mounted = true;
        if (this.props.shouldLoadScript) {
            // load the codepen embed script
            this.scriptTagBuilder.appendTo(document.body);
        }
    };
    ReactCodepen.prototype.componentWillUnmount = function () {
        this._mounted = false;
    };
    ReactCodepen.prototype.render = function () {
        if (this.isLoaded() || this.props.loader) {
            return (React.createElement("div", { "data-height": this.props.height, "data-theme-id": this.props.themeId, "data-slug-hash": this.props.hash, "data-default-tab": this.props.defaultTab, "data-user": this.props.user, "data-embed-version": this.props.version, "data-pen-title": this.props.title, "data-preview": this.props.preview, className: "codepen" }, this.getContent()));
        }
        else {
            return null;
        }
    };
    ReactCodepen.prototype.isLoaded = function () {
        return this.props.overrideAsLoaded || this.state.loaded;
    };
    ReactCodepen.prototype.handleScriptLoad = function () {
        // do not do anything if the component is already unmounted.
        if (!this._mounted)
            return;
        this.setState({
            loaded: true,
            loading: false
        });
    };
    ReactCodepen.prototype.handleScriptError = function () {
        if (!this._mounted)
            return;
        this.setState({
            error: 'Failed to load the pen'
        });
    };
    ReactCodepen.prototype.getContent = function () {
        if (this.isLoaded()) {
            var penLink = "https://codepen.io/" + this.props.user + "/pen/" + this.props.hash + "/";
            var userProfileLink = "https://codepen.io/" + this.props.user;
            return (React.createElement("div", null,
                "See the Pen ",
                React.createElement("a", { href: penLink }, this.props.title),
                "by ",
                this.props.user,
                " (",
                React.createElement("a", { href: userProfileLink },
                    "@",
                    this.props.user),
                ") on ",
                React.createElement("a", { href: "https://codepen.io" }, "CodePen"),
                "."));
        }
        else {
            return React.createElement(this.props.loader, {
                isLoading: this.state.loading,
                error: this.state.error
            });
        }
    };
    ReactCodepen.defaultProps = {
        defaultTab: 'css,result',
        height: 300,
        preview: true,
        themeId: 'dark',
        version: 2,
        shouldLoadScript: true
    };
    return ReactCodepen;
}(react_1.Component));
exports.default = ReactCodepen;
//# sourceMappingURL=ReactCodepen.js.map